const api = require('../../utils/api');
Component({

    behaviors: [],

    properties: {
        myProperty: { // 属性名
            type: String,
            value: ''
        },
        myProperty2: String // 简化的定义方式
    },

    /**
     * 页面的初始数据
     */
    data: {
        img: "",
        wechat: "../../images/icon/wechat.png",
        xiazai: "../../images/icon/download.png",
        share: "../../images/icon/share.png",
        maskHidden: false,
        showPoster: false,
        name: "",
        qrcode: '',
        storeName: false
    },

    lifetimes: {
        // 生命周期函数，可以为函数，或一个在methods段中定义的方法名
        attached: function () {
        },
        moved: function () {
        },
        detached: function () {
        },
    },

    // 生命周期函数，可以为函数，或一个在methods段中定义的方法名
    attached: function () {
    }, // 此处attached的声明会被lifetimes字段中的声明覆盖
    ready: function () {
    },

    pageLifetimes: {
        // 组件所在页面的生命周期函数
        show: function () {

        },
        hide: function () {
        },
        resize: function () {
        },
    },

    methods: {

        setInfo: function (data) {
            //console.log('setInfo',data);
            var that = this;
            wx.showLoading({title: '分享码获取中...'})
            api.getProductShareCode({token: api.get_token(), id: data.id}, function (ret) {
                //console.log('qr',res)
                wx.hideLoading();
                if (ret.data.code != 0) {
                    return wx.showToast({title: ret.data.msg, duration: 2000, icon: 'none'})
                } else {
                    that.downLoad(data.goods_img);
                    wx.downloadFile({
                        url: ret.data.data,
                        success(res) {
                            that.setData({
                                qrcode: res.tempFilePath
                            });

                            that.setData({
                                maskHidden: false,
                                name: data.title,
                                storeName: ret.data.storeName
                            });
                            if (ret.data.canvas) {
                                that.setData({
                                    canvasWidth: ret.data.canvas.width,
                                    canvasHeight: ret.data.canvas.height,
                                })
                            }
                            that.formSubmit()
                        }
                    })
                }
            });
        },

        downLoad: function (url) {
            var that = this;
            wx.downloadFile({
                url: url,
                type: 'image',
                success(res) {
                    that.setData({
                        img: res.tempFilePath
                    });
                },
                fail(res) {
                    console.log('dfail', res)
                }
            });
        },

        onMyButtonTap: function () {
            this.setData({
                // 更新属性和数据的方法与更新页面数据的方法类似
            })
        },
        // 内部方法建议以下划线开头
        _myPrivateMethod: function () {
            // 这里将 data.A[0].B 设为 'myPrivateData'
            this.setData({
                'A[0].B': 'myPrivateData'
            })
        },
        _propertyChange: function (newVal, oldVal) {

        },


        //生成临时图片
        handleNetImg: function (imagePath) {
            return new Promise((resolve, reject) => {
                wx.getImageInfo({
                    src: imagePath,
                    success: function (res) {
                        resolve(res);
                    }
                });
            });
        },

        //将canvas转换为图片保存到本地，然后将图片路径传给image图片的src
        createNewImg: function () {
            wx.showLoading({title: '海报印刷中...'});
            var that = this;
            var canvasHeight = that.data.canvasHeight ? that.data.canvasHeight : 500;
            var canvasWidth = that.data.canvasWidth ? that.data.canvasWidth : 375;
            var dx = 38;
            var dy = 38;
            var marginTop = 20;//相对上一内容的高度
            //第二个参数确保不会出现空白情况
            var context = wx.createCanvasContext('mycanvas', that);
            context.setFillStyle("#fff");//白色背景
            context.fillRect(0, 0, canvasWidth, canvasHeight);//定义画布大小
            //var path = "/images/temp/1.png";
            var path = that.data.img;
            var dheight = 300;//图像的宽度
            var dwidth = 300;//图像的高度
            wx.getImageInfo({
                //src: path,
                src: that.data.img,
                success: function (res) {
                    dheight = (res.height * dwidth / res.width);//根据宽度计算新高度
                }
            });
            //第一张图片定义一个位置贴到画布上
            context.drawImage(path, dx, dy, dwidth, dheight);
            dheight += dy + marginTop;

            var name = that.data.name;
            context.setFontSize(14);
            context.setFillStyle('#333');
            context.setTextAlign('left');
            var chr = name.split("");//这个方法是将一个字符串分割成字符串数组
            var temp = "";
            var row = [];
            for (var a = 0; a < chr.length; a++) {
                if (context.measureText(temp).width < dwidth) {
                    temp += chr[a];
                } else {
                    a--; //这里添加了a-- 是为了防止字符丢失，效果图中有对比
                    row.push(temp);
                    temp = "";
                }
            }
            row.push(temp);
            //如果数组长度大于2 则截取前两个
            if (row.length > 2) {
                var rowCut = row.slice(0, 2);
                var rowPart = rowCut[1];
                var test = "";
                var empty = [];
                for (var i = 0; i < rowPart.length; i++) {
                    if (context.measureText(test).width < dwidth) {
                        test += rowPart[i];
                    } else {
                        break;
                    }
                }
                empty.push(test);
                var group = empty[0] + "...";//这里只显示两行，超出的用...表示
                rowCut.splice(1, 1, group);
                row = rowCut;
            }
            for (var b = 0; b < row.length; b++) {
                dheight += b * 30;//自增内容高度
                context.fillText(row[b], dx, dheight, dwidth);//距离上面的图片一点空隙
                // canvasHeight += b * 30;//重设画布高度
            }
            context.stroke();

            //绘制左下角文字
            context.setFontSize(14);
            context.setFillStyle('#333');
            context.setTextAlign('left');
            context.fillText("长按识别小程序", dx + 20, dheight + marginTop * 3, dwidth / 2);
            context.stroke();
            context.setFontSize(14);
            context.setFillStyle('#333');
            context.setTextAlign('left');
            context.fillText("进入详情查看更多...", dx + 20, dheight + marginTop * 4, dwidth / 2);
            context.stroke();
            // console.log(that.data.storeName)
            if (that.data.storeName) {
                context.setFontSize(16);
                context.setFillStyle('#4b28ff');
                context.setTextAlign('left');
                context.fillText('店铺ID：' + that.data.storeName, dx + 20, dheight + marginTop * 6, dwidth / 2);
                context.stroke();
            }
            //绘制右下角小程序二维码
            //var qrcodePath = "/images/qd.png";//二维码
            var qrcodePath = that.data.qrcode
            context.drawImage(qrcodePath, dwidth / 2 + (dwidth / 2 - 80) / 2 + 20, dheight + marginTop, 80, 80);

            //将生成好的图片保存到本地
            context.draw();


            //画就完了
            setTimeout(function () {

                wx.canvasToTempFilePath({
                    canvasId: 'mycanvas',
                    x: 0,
                    y: 0,
                    height: canvasHeight,
                    width: canvasWidth,
                    fileType: 'png',//png无损压缩，jpg是有损压缩
                    quality: 1,//图片的质量，目前仅对 jpg 有效。取值范围为 (0, 1]，不在范围内时当作 1.0 处理。
                    success: function (res) {
                        //console.log(res)
                        var tempFilePath = res.tempFilePath;
                        that.setData({
                            imagePath: tempFilePath,
                            canvasHidden: true
                        });
                    },
                    fail: function (res) {
                        console.log(res);
                    }
                }, that);
            }, 200);
            wx.hideLoading();
        },

        //点击保存到相册
        baocun: function () {
            var that = this;
            //console.log('data', that.data);
            wx.saveImageToPhotosAlbum({
                filePath: that.data.imagePath,
                success(res) {
                    wx.showModal({
                        content: '海报已保存到相册',
                        showCancel: false,
                        confirmText: '确定',
                        confirmColor: '#333',
                        success: function (res) {
                            if (res.confirm) {
                                //console.log('用户点击确定');
                                /* 该隐藏的隐藏 */
                                that.setData({
                                    maskHidden: false,
                                    showPoster: false
                                })
                            }
                        }, fail: function (res) {
                            console.log(11111)
                        }
                    })
                }
            })
        }
        ,
        //点击生成
        formSubmit: function () {
            var that = this;

            this.setData({
                maskHidden: false,
                showPoster: true
            });
            wx.showToast({
                title: '海报生成中...',
                icon: 'loading',
                duration: 1000
            });
            setTimeout(function () {
                wx.hideToast()
                that.createNewImg();
                that.setData({
                    maskHidden: true
                });
            }, 1000)
        }
        ,
    }

})
;
